import { defineComponent, ref, resolveComponent, openBlock, createElementBlock, Fragment, createVNode, mergeProps, withCtx, renderList, createBlock, normalizeProps, renderSlot } from 'vue';
import { ElTable, ElTableColumn } from '../../table/index.mjs';
import { MgPagination } from '../../mg-pagination/index.mjs';
import '../../../utils/index.mjs';
import '../../../hooks/index.mjs';
import TableProps, { DefaultPageCfgLayout } from './constant.mjs';
import _export_sfc from '../../../_virtual/plugin-vue_export-helper.mjs';
import { useNamespace } from '../../../hooks/use-namespace/index.mjs';
import { isUndefined } from '../../../utils/types.mjs';

const _sfc_main = defineComponent({
  name: "MgTable",
  components: {
    ElTable,
    ElTableColumn,
    MgPagination
  },
  props: TableProps,
  setup(props) {
    const ns = useNamespace("table", ref("mg"));
    const elTableRef = ref();
    return {
      ns,
      elTableRef,
      isUndefined,
      DefaultPageCfgLayout
    };
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_el_table_column = resolveComponent("el-table-column");
  const _component_el_table = resolveComponent("el-table");
  const _component_mg_pagination = resolveComponent("mg-pagination");
  return openBlock(), createElementBlock(Fragment, null, [
    createVNode(_component_el_table, mergeProps(_ctx.$attrs, {
      ref: "elTableRef",
      border: _ctx.borderType !== "default",
      class: [
        _ctx.ns.b(),
        {
          [_ctx.ns.m("outer-border")]: _ctx.borderType === "outer"
        }
      ]
    }), {
      default: withCtx(() => [
        (openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.cfg, (item) => {
          return openBlock(), createElementBlock(Fragment, {
            key: item.prop
          }, [
            _ctx.isUndefined(item.slotKey) ? (openBlock(), createBlock(_component_el_table_column, normalizeProps(mergeProps({ key: 0 }, item)), null, 16)) : renderSlot(_ctx.$slots, item.slotKey, { key: 1 })
          ], 64);
        }), 128))
      ]),
      _: 3
    }, 16, ["border", "class"]),
    createVNode(_component_mg_pagination, mergeProps({
      border: "",
      class: [_ctx.ns.m("page")]
    }, {
      layout: _ctx.DefaultPageCfgLayout,
      ..._ctx.pageCfg
    }), null, 16, ["class"])
  ], 64);
}
var MyTable = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__file", "/Users/chenghsu/Documents/bty/bty-element/packages/components/mg-table/src/mg-table.vue"]]);

export { MyTable as default };
//# sourceMappingURL=mg-table.mjs.map
